/**********************************************************************************************************************************************
Project 			: Bibi
Version 			: 2.3
Date    			: 09-03-2012
Author  			: Dennis van Elteren                           
Chip type           : STM32F100 (VLDISCOVERY board, medium density value line ARM M3 cortex)
Program type        : Application
Clock frequency     : 24,000000 MHz	(Keil uVision: press ALT-F7, go to C/C++ tab. Defined is: STM32F10X_MD_VL. ST firmware chooses 24Mhz as CLK

Versie history:
1.0     -       Startversie, TIM3 geeft 4 pwm signalen op zijn 4 kanalen. In loop in main heb ik het nu voor elkaar dat er een 1 tot 2mS PWM puls
				op ch1 van TIM3 te zien is. Ik doe dit echter met een domme delay (wachtloopje) van 1mS en de PWM puls gaat in 2000 stapjes van 1 naar 2mS en terug
1.1		-		Nu TIM4 erbij doen waarbij TIM3 dan de 4 armen vd robot bestuurt en TIM4 de bijbehorende 4 knieen
				Deze versie heeft al een basic loopalgoritme en een rusttoestand bij poweron van 3 seconden
1.2		-		Nieuw principe vd mechanica, elke poot heeft nu een rubber voet die zelf ook vrij kan draaien
				Alle 3 standen van de armen zijn nu op elkaar afgestemd en nu ga ik lopen2 dusdanig modificeren dat
				deze constructie kan lopen (dat wordt V1.3)
1.3		-		Lopen2 verbouwd zodat ie met de mechanica wijziging van V1.2 overweg kan
1.4		-		Lopen3 ingebouwd, dit is een algoritme van iemand van internet (robot Cane) en nu loopt ie wel mooi!
1.5		-		Lopen3 heet nu lopen en lopen1 en 2 zijn weg. Tevens verbeteren van het rechtuitlopen door alle standen
				van de servo armen en knie-en gelijk te maken
1.6		-		Tal van functies toegevoegd voor zetten X stappen, andere rusttoestanden servo's en achteruitlopen
1.7		-		Body-leds geimplementeerd die worden aangestuurd via TIM2. De LEDs laten de plexiglazen body oplichten
1.8		-		Body led dimmer via TIM2 nu via interrupt handler, vanaf nu moet bij een versiebackup ook stm32f10x_it.c en
				stm32f10x_it.h gebackupped worden. In deze versie gaat TIM2 CH4 een irq genereren. In de interrupt handler
				code wordt dan de PWM dutycycle van CH1 (waar een LED aan zit) geincrementeerd met 1. De frequentie van de IRQ
				moet dus een mooie waarde krijgen (c.a 12uS) om de led mooi te laten dimmen
1.9		-		FInetuning links,rechts en achteruit uitgevoerd
1.10	-		Ontdekt dat RV en LA hun pootje van de grond andersom moeten doen zodat de robot op dat moment stabieler is
				Paar nieuwe defines gemaakt en de 4 loopfuncties aangepast op het nieuwe inzicht.
2.0		-		Sensor time. Ik start met 2 pan/tilt servo's aan de voorzijde, deze moeten gestuurd worden.	Doe ik met TIM1
				Ik begin met PWM voor pan/tilt op CH1+2
2.1		-		HC-SR04 IR distance sensor toegevoegd, Trig pulse is bitbanged op PB13 en decoderen echo is met CH1 / PB14 van TIM15.
				Tim15 is remapped zodat de channels op pinnen komen die 5V tolerant zijn. IRQ op CH1 input flanken, op rising edge wordt
				TIM15 genuld, op falling edge wordt input capture gelatcht. TIM15 op 1MHz dus 1 count is 1uS, verschil in tellen is hoog
				tijd in uS, deel dat door 58 is afstand in cm (integer afgerond)
2.2		-		Versie waarin afstandmeting continue of single measurement gekozen kan worden. Daarnaast loopt Bibi vooruit totdat een
				obstakel dichterbij dan 30cm is. Hierop wordt gestopt, links en rechts gekeken waar de meeste ruimte is om verder te
				lopen en daarna verder gelopen in die richting.
2.3		-		Rare servo moves gezien, daarom deze versie alle irq tasks die naar main while(1) loop verplaatst kunnen, verplaatst.
				In de irq routine zo min mogelijk doen, liefst alleen ophoging variabelen. Loopvooruit heb ik verbeterd op zelfde manier
				als loopachteruit: pootjes RV en LA trek ik bij optillen nu naar binnen ipv naar buiten te brengen. 
				Tevens stack size groter gemaakt in regel 033 van startup_stm32f10x_md_vl.s


---------------------------------------------------------------------------------------------------------------------------------------------
PINCONNECTIES
---------------------------------------------------------------------------------------------------------------------------------------------
TIM1voor HC-SR04 ultrasonic distance sensor
CH1 / PA8 voor PAN servomotor sensor array
CH2 / PA9 voor TILT servomoter sensor array
CH3 / PA10 vrij
CH4 / PA11 vrij

TIM2 voor IRQ genereren en PWM signalen 
CH1 / PA0 - PWM output voor dimmen 4 groene leds 
CH2 / PA1 - PWM output voor dimmen 4 rode leds
CH3 / PA2 nog vrij (is tevens USART2 TX)
CH4 / PA3 voor IRQ + routine CH1 en CH2 aanstuurt (tevens USART2 RX)

TIM3 (remapped) voor 4x servo armen
CH1 / PC6 - Servo arm linksachter (zonder remap PA6)
CH2 / PC7 - Servo arm rechtsachter (zonder remap PA7)
CH3 / PC8 - Servo arm linksvoor (zonder remap PB0)
CH4 / PC9 - Servo arm rechtsvoor (zonder remap PB1)

TIM4 voor 4x servo benen
CH1 / PB6 - Servo poot linksachter
CH2 / PB7 - Servo poot rechtsachter
CH3 / PB8 - Servo poot linksvoor
CH4 / PB9 - Servo poot rechtsvoor

TIM15 (remapped) voor HC-SR04 distance censor trigger en decode
CH1 /PB14 voor meten puls die terug komt (of neem externe pin interrupt ofzo)
CH2 / PB15 vrij 

USART3 voor uCam-TTL camera
PB10 - USART3_TX 
PB11 - USART3_RX 

Algemeen
PB13 voor genereren puls 10mS 
PB12 voor een debugled / debugsignaal

                
ACTUELE STATUS:
Afstandsensor werkt nu maar ander probleem: bibi loopt vast, gaat meestal slome servo moves aan vooraf
Ik doe nu het afstandmeten in de while (1) lus in main en niet meer continue
Probleem gelocaliseerd: wachten tot afstandmeting klaar is duurt soms erg lang, als de afstand erg groot is vooral
Wat ik moet doen: in irq nu echt niets meer doen dan wat variabelen ophogen en niet meer pollen tot meting klaar is.
Op zich wordt er al geen nw puls meer afgegeven als metingloopt=1 dus dat is wel afgedekt
-->update: zoveel mogelijk verwijderd en bibi doet t nu beter. Loopt tot nu toe niet vast. Wat ik nog wel zie is af
en toe slomere moves, zal komen omdat de irq routine nog steeds redelijk veel code is maar is niets aan te doen...
 
TODO:
-verder nog de LED driver PWM IC's implementeren die ik gekocht had
-5V buck/boost nodig voor 5V circuits
- LED dim algoritme maken dat op en neer gaat in de TIM2 irq routine
-maak 1 functie die TIMx aanstuurt per kanaal (TIMx is TIM1 of 2 of 3 of 4) ipv 4 losse
**********************************************************************************************************************************************/

#include "stm32f10x.h" //entry point van de ST library: hier begint het mee
#include <stdio.h>
#define PORTC_EN_REMAP  //PIN REMAP: TIM3 nu op PC6..PC9 = CH1...4. Schakel deze uit voor TIM3 CH1=PA6 CH2=PA7 CH3=PB0 CH4=PB1 (zie Datasheet_STM32F100xx_CD00251732.pdf)

//Voor elke servo een define, LA is linksachter, RA rechtsachter, LV linksvoor, RV rechtsvoor
#define	knieLVnaarbuiten 	2000
#define	knieLAnaarbuiten 	2000
#define	knieRVnaarbuiten 	2000
#define	knieRAnaarbuiten 	2000

#define	knieLVmidden 		3300
#define	knieLAmidden 		3300
#define	knieRVmidden 		3300
#define	knieRAmidden 		3300

#define	knieLVnaarbinnen	4100 //4125 lager is naar buiten
#define	knieLAnaarbinnen	3900 //4050 lager=naar buiten
#define	knieRVnaarbinnen	5050  //hoger is naar binnen
#define	knieRAnaarbinnen	4400 //4675 hoger is naar binnen

#define knieLVmaxnaarbinnen 5000	 //Knie bijna helemaal naar binnen tegen bracket aan, handige pose ivm stabiliteit bij lopen
#define knieLAmaxnaarbinnen 4850
#define knieRVmaxnaarbinnen	5600 
#define knieRAmaxnaarbinnen	5200

#define knieLVoptillen		2800 //lagere waarde is meer naar buiten dus meer optillen
#define knieLAoptillen		2800
#define knieRVoptillen		4200
#define knieRAoptillen		3500

#define	armLVnaarachtermax	4500 //tot 5000 gaat goed
#define	armLAnaarachtermax	5000 //tot 5000 gaat goed
#define	armRVnaarachtermax	1800  
#define	armRAnaarachtermax	1900

#define	armLVnaarvorenmax 	1650 
#define	armLAnaarvorenmax	1550  //2400 geeft goede stand servo zonder dat hij stroom blijft trekken. 1800 kan icm timer disablen na bereiken eindpositie 
#define	armRVnaarvorenmax 	5000 //tot 5000 gaat goed  
#define	armRAnaarvorenmax 	5000 //tot 5000 gaat goed  

//loopconstanten armen 
#define	armLVnaarvoren 		1750
#define armLVhalfnaarvoren	2475
#define	armLAnaarvoren 		2000 
#define armLAhalfnaarvoren 	2625
#define	armRVnaarvoren 		4450 
#define armRVhalfnaarvoren	3750
#define	armRAnaarvoren 		4450 
#define armRAhalfnaarvoren	3750

#define	armLVmidden 		3200  
#define	armLAmidden 		3250  
#define	armRVmidden 		3050 
#define	armRAmidden 		3045  

#define	armLVnaarachter		4600 
#define armLVhalfnaarachter	3900
#define	armLAnaarachter		4800
#define armLAhalfnaarachter 4025
#define	armRVnaarachter		1700 //was 1800 toen de robot te ver naar rechts ging
#define armRVhalfnaarachter	2375
#define	armRAnaarachter		1800
#define armRAhalfnaarachter	2425

//constanten pan/tilt servo's voorop
#define pan			1
#define tilt		2 
#define panmid		3400
#define panR		4700
#define panL		1900
#define tiltmid		3700
#define tiltup		4700
#define tiltdown	2100
	

//delay constanten
#define 	kort	25	  //handig voor debug
#define		normal	35	 //35
#define		back	30   //speciale delay voor achteruit
#define		delta	0	//voor finetuning van het lopen

#define		achteruit	0
#define 	vooruit		1
#define		links		2
#define		rechts		3

#define		aan			1
#define		uit			0

#define		single		2
#define		continue	3

#define		aantalmetingen	10 //ter debug, zie in main while(1) loop voor gebruik
#define		marge		20	//gebruikt in ontwijk() om een nieuwe richting te kiezen die tenminste 'treshold' + 'marge' aantal cm geen obstakel heeft boven


//TIM_TimeBaseInitTypeDef en TIM_OCInitTypeDef zijn structs die gedefinieerd zijn in stm32f10x_tim.c
TIM_TimeBaseInitTypeDef  TIM1_TimeBaseStructure; //voor pan/tilt servo's
TIM_TimeBaseInitTypeDef  TIM2_TimeBaseStructure; //voor LED pwm-en in plexiglazen body bibi
TIM_TimeBaseInitTypeDef  TIM3_TimeBaseStructure; //definitie TIM_TimeBaseStructure van type TIM_TimeBaseInitTypeDef wat een struct is en dus heeft TIM_TimeBaseStructure ook de members van TIM_TimeBaseInitTypeDef
TIM_TimeBaseInitTypeDef  TIM4_TimeBaseStructure; //idem
TIM_TimeBaseInitTypeDef  TIM15_TimeBaseStructure;//voor aansturen SR-CH4 ultrsonic sensor
TIM_OCInitTypeDef  TIM1_OCInitStructure; //	//voor pan/tilt servo's
TIM_OCInitTypeDef  TIM2_OCInitStructure;  //voor TIM2 voor het PWM-en van de leds die in het plexiglas vd body zitten
TIM_OCInitTypeDef  TIM3_OCInitStructure;	//hier net zo, TIM_OCInitStructure is van struct type TIM_OCInitTypeDef en dient voor timer instellingen
TIM_OCInitTypeDef  TIM4_OCInitStructure;
TIM_OCInitTypeDef  TIM15_OCInitStructure;  //voor aansturen SR-CH4 ultrsonic sensor
TIM_ICInitTypeDef  TIM15_ICInitStructure;  //voor TIM15 instellen voor terugmeten SR-CH4 echopulse 
NVIC_InitTypeDef NVIC_InitStructure; //voor interrupts instellen

//macro's voor TIM2 IRQ modus
__IO uint16_t CCR1_Val = 40961;	   //__IO definieert de R/W permissies, hier is dat R en W, uint16_t is de exacte breedte van een unsigned short en 40961 is alleen een waarde
__IO uint16_t CCR2_Val = 27309;
__IO uint16_t CCR3_Val = 13654;
__IO uint16_t CCR4_Val = 6826;

//initieele waardes dutycycles pwm TIM3 en TIM4
uint16_t TIM3CCR1_Val = 3250; 
uint16_t TIM3CCR2_Val = 3250;
uint16_t TIM3CCR3_Val = 3250; 
uint16_t TIM3CCR4_Val = 3250;
uint16_t TIM4CCR1_Val = 3250; 
uint16_t TIM4CCR2_Val = 3250;
uint16_t TIM4CCR3_Val = 3250; 
uint16_t TIM4CCR4_Val = 3250;
uint16_t PrescalerValue = 0;  //prescaler register vd timer
uint8_t count = 0;	 //ingebouwd om meerdere delays achter elkaar te kunnen bouwen

extern volatile uint16_t afstand; //gedeclareerd en van waarde veranderd in stm32f10x_it.c
extern volatile uint16_t fase;
uint8_t continuemeten=0;	//default meten we NIET continue de afstand via TIM2 irq routine handler
volatile uint8_t metingloopt=0;
uint16_t aantalmetingengestart=0;
volatile extern uint16_t goedafgehandeld,foutafgehandeld;
uint16_t alleafstanden[aantalmetingen];
volatile extern uint8_t obstakel;
//volatile extern uint16_t pwmleddutycycle; //voor LED dimmer, wordt in TIM2_IRQHandler in stm32f10x_it.c gemanipuleerd

/* Private function prototypes -----------------------------------------------*/
void RCC_Configuration(void);  //CLK configureren
void GPIO_Configuration(void); //GPIO configureren
void NVIC_Configuration(void); //Interrupts configureren
void setTIM1CHxDuty(uint16_t channel, uint16_t duty); //CH1+2 voor pan+tilt ultrasonic sensor 
void setTIM2CHxDuty(uint16_t channel, uint16_t duty);
void setTIM3CHxDuty(uint16_t channel, uint16_t duty); //eigen functie om van timer3 het kanaal en dutycycle voor PWM signaal te kiezen
void setTIM4CHxDuty(uint16_t channel, uint16_t duty);
void delayms(uint16_t delayms);
void delayus(uint16_t delayus);
void meetafstand(uint8_t modus); //voor het meten van de afstand tot het dichtstbijzijnde object/obstakel , modi zijn aan (geen meting), uit, single of continue
void tim2irqsaanuit(uint8_t aanuit);
void HCSR04trig(void);//nodig om de afstandmeting te starten in meetafstand()
void rusttoestand(void); 
void actierusttoestand(void);
void timerinit(void);
void debugfunctie(void);
void loopvooruit(void); //volgens quadropod robotje Cane van internet
void loopachteruit(void);
void draailinks(void);
void draairechts(void);
void loopXstappen(uint32_t aantalstappen, uint8_t richting);
void stop(void);
void debugled(uint8_t aanuit);
void demo(void);
void setpanservo(uint16_t stand);
void ontwijk(void); //bepaalt mbv de HC-SR04 afstandssensor welke kant de robot op zal ontwijken
void pollsingleafstandmetingklaar(void);

/* Private functions ------------------------------------------------------------------------------------------------------------------------------*/
int main(void)
{

/*At this stage the microcontroller clock setting is already configured, this is done through SystemInit() function which is called 
from startup file (startup_stm32f10x_xx.s) before to branch to application main. To reconfigure the default setting of SystemInit()
function, refer to system_stm32f10x.c file */ 

/*DVE: Instelling CLOCK frequentie
mijn discoveryboard is uit de reeks MD_VL ofwel medium density value line en daarom gebruikt mijn board als opstartcode 
startup_stm32f10x_md_vl.s. De SystemCoreClock wordt geset in system_stm32f10x.c in regel 149 en verder en is afhankelijk van
het feit welke define er is gedaan voor SYSCLK_FREQ_xxMHz waarbij xx een getal is. Deze define op zijn beurt is gedaan in regel 108.
Want in de project->options->C/C++ regel defines staat gedefinieerd define STM32F10X_MD_VL	
(DISCOVERY Board is Medium Density Value Line) 
EINDCONCLUSIE: CLK=SystemCoreClock=24Mhz voor mijn discovery board  */
       
  
  //deze actie uitvoeren nog voordat de interrupts aan gaan ivm opstartgedrag
  meetafstand(uit); 

  /* System Clocks Configuration */
  RCC_Configuration();

  /* NVIC Configuration */
  NVIC_Configuration();

  /* GPIO Configuration */
  GPIO_Configuration();
  delayms(1); 

  //instellen TIM1, TIM2, TIM3 en TIM4
  timerinit();
 
  actierusttoestand();

  //pan servo in middenstand zetten
  setpanservo(panmid);
  delayms(500);

  meetafstand(uit);

  //Bibi loopt vooruit totdat een obstakel gezien wordt (interrupt gestuurd) en ontweken wordt		 
  while(1)
  {
	meetafstand(single);
	//pollsingleafstandmetingklaar();
	if (obstakel == 1)
		ontwijk();
	//meetafstand(uit);
	loopvooruit(); 
  }   
  
} //einde main is hier

void rusttoestand(void)
{
	//de rusttoestanden heb ik nu icm de defines bovenaan voor alle 4 de poten gelijk nu de uiterste standen vh lopen
	TIM_Cmd(TIM3, ENABLE); //hoort bij regel 160/161 voor disablen motorsturing na bereiken eindpositie
	setTIM3CHxDuty(1,armLAmidden); 
	setTIM3CHxDuty(2,armRAmidden); 
	setTIM3CHxDuty(3,armLVmidden); 
	setTIM3CHxDuty(4,armRVmidden); 
	setTIM4CHxDuty(1,knieLAnaarbinnen);
	setTIM4CHxDuty(2,knieRAnaarbinnen);
	setTIM4CHxDuty(3,knieLVnaarbinnen);
	setTIM4CHxDuty(4,knieRVnaarbinnen);
	delayms(150);
	TIM_Cmd(TIM3, DISABLE);
}

void actierusttoestand(void)
{
	TIM_Cmd(TIM3, ENABLE); 
	setTIM3CHxDuty(1,armLAnaarachter); 
	setTIM3CHxDuty(2,armRAnaarachter); 
	setTIM3CHxDuty(3,armLVnaarvoren); 
	setTIM3CHxDuty(4,armRVnaarvoren); 
	setTIM4CHxDuty(1,knieLAnaarbinnen);
	setTIM4CHxDuty(2,knieRAnaarbinnen);
	setTIM4CHxDuty(3,knieLVnaarbinnen);
	setTIM4CHxDuty(4,knieRVnaarbinnen);
	delayms(150);
	TIM_Cmd(TIM3, DISABLE);
}

//zet X stappen vooruit	of achteruit
void loopXstappen(uint32_t aantalstappen, uint8_t richting)
{
	uint32_t i;

	TIM_Cmd(TIM3, ENABLE);
	TIM_Cmd(TIM4, ENABLE);

	for (i=0; i<aantalstappen; i++)
	{
		if (richting==vooruit)
			loopvooruit();
		else if(richting==links)
			draailinks();
		else if(richting==rechts)
			draairechts();
		else loopachteruit();
	}
	
	stop();		
}

void stop(void)
{
	setTIM4CHxDuty(1,knieLAnaarbinnen);
	setTIM4CHxDuty(2,knieRAnaarbinnen);
	setTIM4CHxDuty(3,knieLVnaarbinnen);
	setTIM4CHxDuty(4,knieRVnaarbinnen);
	delayms(normal);
	TIM_Cmd(TIM3, DISABLE);	
	TIM_Cmd(TIM4, DISABLE);
}

void setTIM1CHxDuty(uint16_t channel, uint16_t duty)
{
	switch (channel){
	case 1:
		TIM1_OCInitStructure.TIM_Pulse = duty;
		TIM_OC1Init(TIM1, &TIM1_OCInitStructure);
		TIM_OC1PreloadConfig(TIM1, TIM_OCPreload_Enable);
		break;	
	case 2:
		TIM1_OCInitStructure.TIM_Pulse = duty;
		TIM_OC2Init(TIM1, &TIM1_OCInitStructure);
		TIM_OC2PreloadConfig(TIM1, TIM_OCPreload_Enable);
		break;
	/* alleen CH1+2 voor PWM
	case 3:
		TIM1_OCInitStructure.TIM_Pulse = duty;
		TIM_OC3Init(TIM1, &TIM1_OCInitStructure);
		TIM_OC3PreloadConfig(TIM1, TIM_OCPreload_Enable);
		break;
	case 4:
		TIM1_OCInitStructure.TIM_Pulse = duty;
		TIM_OC4Init(TIM1, &TIM1_OCInitStructure);
		TIM_OC4PreloadConfig(TIM1, TIM_OCPreload_Enable);
		break;
	*/
	default:
		break;
	}
}

void setTIM2CHxDuty(uint16_t channel, uint16_t duty)
{
	switch (channel){
	case 1:
		TIM2_OCInitStructure.TIM_Pulse = duty;
		TIM_OC1Init(TIM2, &TIM2_OCInitStructure);
		//TIM_OC1PreloadConfig(TIM2, TIM_OCPreload_Enable);
		break;	
	case 2:
		TIM2_OCInitStructure.TIM_Pulse = duty;
		TIM_OC2Init(TIM2, &TIM2_OCInitStructure);
		//TIM_OC2PreloadConfig(TIM2, TIM_OCPreload_Enable);
		break;
	case 3:
		TIM2_OCInitStructure.TIM_Pulse = duty;
		TIM_OC3Init(TIM2, &TIM2_OCInitStructure);
		//TIM_OC3PreloadConfig(TIM2, TIM_OCPreload_Enable);
		break;
	case 4:	 //channel voor irq generatie gebruikt
		break;
	default:
		break;
	}
}
void setTIM3CHxDuty(uint16_t channel, uint16_t duty)	 
{
	switch (channel){
	case 1:
		TIM3_OCInitStructure.TIM_Pulse = duty;
		TIM_OC1Init(TIM3, &TIM3_OCInitStructure);
		//TIM_OC1PreloadConfig(TIM3, TIM_OCPreload_Enable);
		break;	
	case 2:
		TIM3_OCInitStructure.TIM_Pulse = duty;
		TIM_OC2Init(TIM3, &TIM3_OCInitStructure);
		//TIM_OC2PreloadConfig(TIM3, TIM_OCPreload_Enable);
		break;
	case 3:
		TIM3_OCInitStructure.TIM_Pulse = duty;
		TIM_OC3Init(TIM3, &TIM3_OCInitStructure);
		//TIM_OC3PreloadConfig(TIM3, TIM_OCPreload_Enable);
		break;
	case 4:
		TIM3_OCInitStructure.TIM_Pulse = duty;
		TIM_OC4Init(TIM3, &TIM3_OCInitStructure);
		//TIM_OC4PreloadConfig(TIM3, TIM_OCPreload_Enable);
		break;
	default:
		break;
	}
}


void setTIM4CHxDuty(uint16_t channel, uint16_t duty)
{
	switch (channel){
	case 1:
		TIM4_OCInitStructure.TIM_Pulse = duty;
		TIM_OC1Init(TIM4, &TIM4_OCInitStructure);
		//TIM_OC1PreloadConfig(TIM4, TIM_OCPreload_Enable);
		break;
	case 2:
		TIM4_OCInitStructure.TIM_Pulse = duty;
		TIM_OC2Init(TIM4, &TIM4_OCInitStructure);
		//TIM_OC2PreloadConfig(TIM4, TIM_OCPreload_Enable);
		break;
	case 3:
		TIM4_OCInitStructure.TIM_Pulse = duty;
		TIM_OC3Init(TIM4, &TIM4_OCInitStructure);
		//TIM_OC3PreloadConfig(TIM4, TIM_OCPreload_Enable);
		break;
	case 4:
		TIM4_OCInitStructure.TIM_Pulse = duty;
		TIM_OC4Init(TIM4, &TIM4_OCInitStructure);
		//TIM_OC4PreloadConfig(TIM4, TIM_OCPreload_Enable);
		break;
	default:
		break;
	}
}

void delayms(uint16_t delayms)
{
	uint32_t factor = delayms*24000; //Clk is 24MHz, wil je bijv 200mS dan moet de teller op 200 * 2400 gezet worden

	uint32_t i=0; 

	for (i=factor; i>0; i--) 
		;
}

void delayus(uint16_t delayus)
{
	uint16_t factor = delayus*24; //Clk is 24MHz, wil je 1uS dan is dat 24 klokpulsen

	uint16_t i=0; 

	for (i=factor; i>0; i--) 
		;
}

void HCSR04trig(void)
{
	//make a start pulse of 10uS, the ultrasonic distance sensor will be read out and decoded via TIM15 input capture and irq routine
	if(metingloopt==0)//als vorige meting klaar is
	{
		aantalmetingengestart++;
		metingloopt=1;
		TIM_ClearITPendingBit(TIM15, TIM_IT_CC1);
		GPIOB->BSRR = 0x00002000;//set PB13
		delayus(2);	//2 geeft een 10uS puls
    	GPIOB->BRR  = 0x00002000;//clear PB13
	}
}

//deze functie zet tim2 irq's aan of uit, bij uit zijn led pwm uit en continue afstand ook
void tim2irqsaanuit(uint8_t aanuit)
{
	if (aanuit==uit)
	{
		NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
  		NVIC_InitStructure.NVIC_IRQChannelCmd = DISABLE;
  		NVIC_Init(&NVIC_InitStructure);
	}

	if (aanuit==aan)
	{
		NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
  		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  		NVIC_Init(&NVIC_InitStructure);
	}
	
}

void meetafstand(uint8_t modus)
{
	switch (modus){
	case 0:		//uit: stop alle measurements
		continuemeten=0;
		metingloopt=0;
		NVIC_InitStructure.NVIC_IRQChannel = TIM1_BRK_TIM15_IRQn;	 //dit vond ik in stm32f10x.h voor medium density value line uC's hopelijk werkt t
  		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  		NVIC_InitStructure.NVIC_IRQChannelCmd = DISABLE;
  		NVIC_Init(&NVIC_InitStructure);		
		break;
	case 1:	 //aan: alleen maar zorgen dat er gemeten kan worden maar geen meting starten
		continuemeten=0;
		metingloopt=0;
		NVIC_InitStructure.NVIC_IRQChannel = TIM1_BRK_TIM15_IRQn;	 //dit vond ik in stm32f10x.h voor medium density value line uC's hopelijk werkt t
  		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  		NVIC_Init(&NVIC_InitStructure);	
		break;  	
	case 2:	  //single measurement
		continuemeten=0;
		metingloopt=0;
		NVIC_InitStructure.NVIC_IRQChannel = TIM1_BRK_TIM15_IRQn;	 //dit vond ik in stm32f10x.h voor medium density value line uC's hopelijk werkt t
  		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  		NVIC_Init(&NVIC_InitStructure);		
		HCSR04trig();
		break;
	case 3: //meetmodus automatisch / continue via TIM2 irq routine
		continuemeten=1;
		metingloopt=0;
		NVIC_InitStructure.NVIC_IRQChannel = TIM1_BRK_TIM15_IRQn;	 //dit vond ik in stm32f10x.h voor medium density value line uC's hopelijk werkt t
  		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  		NVIC_Init(&NVIC_InitStructure);	
		break;
	default:
		break;
	}	 
}  

void loopvooruit(void) //volgens quadropod robotje Cane van internet
{
 	TIM_Cmd(TIM4, ENABLE);
	TIM_Cmd(TIM3, ENABLE);

	setTIM4CHxDuty(4,knieRVmaxnaarbinnen);  //pootjes set2 optillen maxnaarbinnen
	setTIM4CHxDuty(1,knieLAmaxnaarbinnen);
	setTIM3CHxDuty(2,armRAnaarachter); //pootjes set1 drukt bibi naar voren
	setTIM3CHxDuty(3,armLVnaarachter);
	delayms(normal/2);

	setTIM3CHxDuty(4,armRVnaarvoren);  //pootjes set2 klaarzetten
	setTIM3CHxDuty(1,armLAnaarvoren);
	delayms(normal+delta);

	setTIM4CHxDuty(4,knieRVnaarbinnen);	//pootjes set2 neerzetten
	setTIM4CHxDuty(1,knieLAnaarbinnen);
	delayms(normal+delta);
	
	setTIM4CHxDuty(3,knieLVoptillen);	 //pootjes set1 optillen
	setTIM4CHxDuty(2,knieRAoptillen); 
	setTIM3CHxDuty(4,armRVnaarachter); 	 //pootjes set2 drukt bibi naar voren
	setTIM3CHxDuty(1,armLAnaarachter);
	delayms(normal/2);

	setTIM3CHxDuty(2,armRAnaarvoren); 	  //pootjes set1 klaarzetten
	setTIM3CHxDuty(3,armLVnaarvoren);
	delayms(normal);

	setTIM4CHxDuty(3,knieLVnaarbinnen);	 //pootjes set1 neerzetten
	setTIM4CHxDuty(2,knieRAnaarbinnen);
	delayms(normal);
}

void loopachteruit(void)
{
	TIM_Cmd(TIM3, ENABLE);
	TIM_Cmd(TIM4, ENABLE);

	setTIM4CHxDuty(4,knieRVmaxnaarbinnen);  //pootjes set2 optillen maxnaarbinnen
	setTIM4CHxDuty(1,knieLAmaxnaarbinnen);
	setTIM3CHxDuty(2,armRAnaarvoren);  //pootjes set1 drukt bibi naar achteren
	setTIM3CHxDuty(3,armLVnaarvoren);
	delayms(normal/2);

	setTIM3CHxDuty(4,armRVnaarachter); 	//pootjes set2 klaarzetten
	setTIM3CHxDuty(1,armLAnaarachter);
	delayms(normal);

	setTIM4CHxDuty(4,knieRVnaarbinnen);	//pootjes set2 neerzetten
	setTIM4CHxDuty(1,knieLAnaarbinnen);
	delayms(normal);
	
	setTIM4CHxDuty(3,knieLVoptillen);  //pootjes set1 optillen
	setTIM4CHxDuty(2,knieRAoptillen); 
	setTIM3CHxDuty(4,armRVnaarvoren); 	 //pootjes set2 drukt bibi naar achteren
	setTIM3CHxDuty(1,armLAnaarvoren);
	delayms(normal/2);

	setTIM3CHxDuty(2,armRAnaarachter); 	//pootjes set1 klaarzetten
	setTIM3CHxDuty(3,armLVnaarachter);
	delayms(normal);

	setTIM4CHxDuty(3,knieLVnaarbinnen);	 //pootjes set1 neerzetten
	setTIM4CHxDuty(2,knieRAnaarbinnen);
	delayms(normal);
}

void draailinks(void) 
{
	TIM_Cmd(TIM3, ENABLE);
	TIM_Cmd(TIM4, ENABLE);

	setTIM4CHxDuty(4,knieRVmaxnaarbinnen);  //pootjes set2 optillen
	setTIM4CHxDuty(1,knieLAmaxnaarbinnen);
	setTIM3CHxDuty(2,armRAhalfnaarachter); //pootjes set1 drukt bibi naar links
	setTIM3CHxDuty(3,armLVhalfnaarvoren);
	delayms(normal/2);

	setTIM3CHxDuty(4,armRVhalfnaarvoren);  //pootjes set2 klaarzetten
	setTIM3CHxDuty(1,armLAhalfnaarachter);
	delayms(normal);

	setTIM4CHxDuty(4,knieRVnaarbinnen);	//pootjes set2 neerzetten
	setTIM4CHxDuty(1,knieLAnaarbinnen);
	delayms(normal);
	
	setTIM4CHxDuty(3,knieLVoptillen);	 //pootjes set1 optillen
	setTIM4CHxDuty(2,knieRAoptillen); 
	setTIM3CHxDuty(4,armRVhalfnaarachter); 	 //pootjes set2 drukt bibi naar links
	setTIM3CHxDuty(1,armLAhalfnaarvoren);
	delayms(normal/2);

	setTIM3CHxDuty(2,armRAhalfnaarvoren); 	  //pootjes set1 klaarzetten
	setTIM3CHxDuty(3,armLVhalfnaarachter);
	delayms(normal);

	setTIM4CHxDuty(3,knieLVnaarbinnen);	 //pootjes set1 neerzetten
	setTIM4CHxDuty(2,knieRAnaarbinnen);
	delayms(normal);
}

void draairechts(void)
{
  	TIM_Cmd(TIM3, ENABLE);
	TIM_Cmd(TIM4, ENABLE);

	setTIM4CHxDuty(4,knieRVmaxnaarbinnen);  //pootjes set2 optillen
	setTIM4CHxDuty(1,knieLAmaxnaarbinnen);
	setTIM3CHxDuty(2,armRAhalfnaarvoren); //pootjes set1 drukt bibi naar voren
	setTIM3CHxDuty(3,armLVhalfnaarachter);
	delayms(normal/2);

	setTIM3CHxDuty(4,armRVhalfnaarachter);  //pootjes set2 klaarzetten
	setTIM3CHxDuty(1,armLAhalfnaarvoren);
	delayms(normal);

	setTIM4CHxDuty(4,knieRVnaarbinnen);	//pootjes set2 neerzetten
	setTIM4CHxDuty(1,knieLAnaarbinnen);
	delayms(normal);
	
	setTIM4CHxDuty(3,knieLVoptillen);	 //pootjes set1 optillen
	setTIM4CHxDuty(2,knieRAoptillen); 
	setTIM3CHxDuty(4,armRVhalfnaarvoren); 	 //pootjes set2 drukt bibi naar voren
	setTIM3CHxDuty(1,armLAhalfnaarachter);
	delayms(normal/2);

	setTIM3CHxDuty(2,armRAhalfnaarachter); 	  //pootjes set1 klaarzetten
	setTIM3CHxDuty(3,armLVhalfnaarvoren);
	delayms(normal);

	setTIM4CHxDuty(3,knieLVnaarbinnen);	 //pootjes set1 neerzetten
	setTIM4CHxDuty(2,knieRAnaarbinnen);
	delayms(normal);
}

void setpanservo(uint16_t stand)
{
 	TIM_Cmd(TIM1, ENABLE);
  	TIM_CtrlPWMOutputs(TIM1, ENABLE);
  	setTIM1CHxDuty(1,stand);
	delayms(200);
	TIM_Cmd(TIM1, DISABLE);
  	TIM_CtrlPWMOutputs(TIM1, DISABLE);
}

void ontwijk(void)
{
	uint16_t grootsteafstand;
	uint8_t draairichting;

	meetafstand(uit);
	stop();
	tim2irqsaanuit(uit);
	delayms(200);
	grootsteafstand=afstand;
	setpanservo(panL);	//kijk links
	delayms(200);
	meetafstand(single); //meet links de afstand tot dichtstbijzijnde obstakel
	pollsingleafstandmetingklaar();
	if (afstand>(grootsteafstand+marge))
	{
		grootsteafstand=afstand;
		draairichting=links;
	}
	else
		draairichting=rechts;
	meetafstand(uit);
	setpanservo(panR);	//kijk nu rechts
	delayms(200);
	meetafstand(single); //meet links de afstand tot dichtstbijzijnde obstakel
	pollsingleafstandmetingklaar();
	delayms(1);
	meetafstand(uit);
	setpanservo(panmid);
  	delayms(200);
	if (afstand>(grootsteafstand+marge))
	{
		grootsteafstand=afstand;
		draairichting=rechts;
		loopXstappen(3,draairichting); //robot draait in de draairichting waarna main() het weer overneemt met vooruit lopen in de nieuwe richting	
	}
	else
		loopXstappen(10,draairichting); //keren	
	obstakel=0;
	tim2irqsaanuit(aan);
	meetafstand(aan); 
}

//wachtlus tot afstandmeting klaar is
//voorzichtig mee zijn, processor kan niets anders doen tijdens deze poll
void pollsingleafstandmetingklaar(void)
{
	while(metingloopt == 1)
		;
}

void demo(void)
{
	loopXstappen(8, vooruit);
  	TIM_Cmd(TIM1, ENABLE);
  	TIM_CtrlPWMOutputs(TIM1, ENABLE);
	setTIM1CHxDuty(pan,panL);
	delayms(250);
	setTIM1CHxDuty(pan,panR);
  	delayms(500);
	TIM_Cmd(TIM1, DISABLE);
  	TIM_CtrlPWMOutputs(TIM1, DISABLE);
	loopXstappen(7, links);
  	delayms(500);
	loopXstappen(5, vooruit);
	TIM_Cmd(TIM1, ENABLE);
  	TIM_CtrlPWMOutputs(TIM1, ENABLE);
	setTIM1CHxDuty(pan,panL);
	delayms(250);
	setTIM1CHxDuty(pan,panR);
  	delayms(500);
	TIM_Cmd(TIM1, DISABLE);
  	TIM_CtrlPWMOutputs(TIM1, DISABLE);
  	loopXstappen(6, achteruit);
	delayms(500);
  	loopXstappen(6, rechts);
	delayms(500);

}

void timerinit(void)
{
/* -------------------------------------------------------------------------------------------------------------------------------------------
info mbt TIM3 (die werd oorspronkelijk gebruikt in het voorbeeld)

The TIM3CLK frequency is set to SystemCoreClock (Hz), to get TIM3 counter
clock at 24 MHz the Prescaler is computed as following: Prescaler = (TIM3CLK / TIM3 counter clock) - 1
    
SystemCoreClock is set to 72 MHz for Low-density, Medium-density, High-density
and Connectivity line devices and to 24 MHz for Low-Density Value line and Medium-Density Value line devices

TIM3 is running at 36 KHz: TIM3 Frequency = TIM3 counter clock/(ARR + 1) = 24 MHz / 666 = 36 KHz
	
Extra uitleg: TIM3 frequency is waar de TIMER uiteindelijk op draait en TIM3 counter clock is de sysclk gedeeld door de
prescaler vd timer. TIM3 Channel1..4 duty cycles = (TIM3_CCR1..4/ TIM3_ARR)* 100   
extra info: TIM3_ARR is hetzelfde als TIM_Period

Voor het maken van Servo PWM signalen is de frequentie standaard 50Hz ofwel 20mS periodetijd
De hoog-tijd varieert van 1-2 mS is volledig linksom of volledig rechtsom. Dit correspondeert met een
Dutycycle van 1mS= 1/20 en 2mS=1/10. Let erop dat het auto-reload register (ARR ofwel TIM_Period) is
betrokken bij zowel dutycycle als PWM frequentie. Om de PWM te maken:
	
-maak van sysclk (24Mhz) 50Hz TIM3+4 CLK met de combi timer prescaler (16bit) en ARR (32bit)
-maak de dutycycle door varieeren CCRx_Val (16bit vd 32 bruikbaar, de MSB's zijn TIM2-only).
-24000000/50 maakt een factor 480000. Met prescaler kan ik 48000 maken en dan ARR nog factor 10.
-Dutycycle is dan (CCR1_Val / 10) * 100 ofwel CCR1_Val * 10
-1mS benodigd CCR1_Val van 100 zodat totaal 1000 wordt in berekening hierboven (1/1E-6)
****************************************************************************************************************************/
  /* TIM3 Time base configuration */
  TIM3_TimeBaseStructure.TIM_Period = 48000;//TIM3 freq instellen mbv auto-reload value (ARR) , 24Mhz/48000 = 500Hz
  TIM3_TimeBaseStructure.TIM_Prescaler = 10;//prescaler van de timer clock, maakt hier 50Hz, berekende waarde regel 063 nog hierdoor delen is eindwaarde clk
  TIM3_TimeBaseStructure.TIM_ClockDivision = 0; //prescaler van de system clock
  TIM3_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //timer telt omhoog
  TIM_TimeBaseInit(TIM3, &TIM3_TimeBaseStructure);  //ik gok zo dat dit nu timer3 instelt volgens voorgaande 4 regels..?

  /* PWM1 Mode configuration: Channel1 */	//zie regel33, TIM3_OCInitStructure is een instantie vd struct TIM_OCInitTypeDef
  //en heeft alle members ervan. Hier worden dus
  TIM3_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;	//pwm mode kiezen
  TIM3_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;	//en dit enablen
  TIM3_OCInitStructure.TIM_Pulse = TIM3CCR1_Val;	 //channel 1 dutycycle instellen, zie regels 10-13 en verhaal regel 059-069
  TIM3_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;	//polariteit van de puls, vlgns mij zelfde als inverted pwm of normal pwm bij avr

  TIM_OC1Init(TIM3, &TIM3_OCInitStructure); //TIM_OC1Init is een functie, parameter TIM3 is een pointer naar de struct
  TIM_OC1PreloadConfig(TIM3, TIM_OCPreload_Enable);

  /* PWM1 Mode configuration: Channel2 */
  TIM3_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM3_OCInitStructure.TIM_Pulse = TIM3CCR2_Val;
  TIM_OC2Init(TIM3, &TIM3_OCInitStructure);
  TIM_OC2PreloadConfig(TIM3, TIM_OCPreload_Enable);

  /* PWM1 Mode configuration: Channel3 */
  TIM3_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM3_OCInitStructure.TIM_Pulse = TIM3CCR3_Val;
  TIM_OC3Init(TIM3, &TIM3_OCInitStructure);
  TIM_OC3PreloadConfig(TIM3, TIM_OCPreload_Enable);

  /* PWM1 Mode configuration: Channel4 */
  TIM3_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM3_OCInitStructure.TIM_Pulse = TIM3CCR4_Val;
  TIM_OC4Init(TIM3, &TIM3_OCInitStructure);
  TIM_OC4PreloadConfig(TIM3, TIM_OCPreload_Enable);
  
  TIM_ARRPreloadConfig(TIM3, ENABLE);

  /* TIM3 enable counter */
  TIM_Cmd(TIM3, ENABLE);

  /* TIM4 Time base configuration */
  TIM4_TimeBaseStructure.TIM_Period = 48000;
  TIM4_TimeBaseStructure.TIM_Prescaler = 10;
  TIM4_TimeBaseStructure.TIM_ClockDivision = 0; //prescaler van de system clock
  TIM4_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //timer telt omhoog
  TIM_TimeBaseInit(TIM4, &TIM4_TimeBaseStructure);  

  /* PWM1 Mode configuration: Channel1 */
  TIM4_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;	//pwm mode kiezen
  TIM4_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;	//en dit enablen
  TIM4_OCInitStructure.TIM_Pulse = TIM4CCR1_Val;	 //channel 1 dutycycle instellen, zie regels 10-13 en verhaal regel 059-069
  TIM4_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;	//polariteit van de puls, vlgns mij zelfde als inverted pwm of normal pwm bij avr

  TIM_OC1Init(TIM4, &TIM4_OCInitStructure); //TIM_OC1Init is een functie, parameter TIM3 is een pointer naar de struct
  TIM_OC1PreloadConfig(TIM4, TIM_OCPreload_Enable);

  /* PWM1 Mode configuration: Channel2 */
  TIM4_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM4_OCInitStructure.TIM_Pulse = TIM4CCR2_Val;
  TIM_OC2Init(TIM4, &TIM4_OCInitStructure);
  TIM_OC2PreloadConfig(TIM4, TIM_OCPreload_Enable);

  /* PWM1 Mode configuration: Channel3 */
  TIM4_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM4_OCInitStructure.TIM_Pulse = TIM4CCR3_Val;
  TIM_OC3Init(TIM4, &TIM4_OCInitStructure);
  TIM_OC3PreloadConfig(TIM4, TIM_OCPreload_Enable);

  /* PWM1 Mode configuration: Channel4 */
  TIM4_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM4_OCInitStructure.TIM_Pulse = TIM4CCR4_Val;
  TIM_OC4Init(TIM4, &TIM4_OCInitStructure);
  TIM_OC4PreloadConfig(TIM4, TIM_OCPreload_Enable);
  
  TIM_ARRPreloadConfig(TIM4, ENABLE);

  /* TIM4 enable counter */
  TIM_Cmd(TIM4, ENABLE);

  /* TIM1 Time base configuration */
  //Ik stel de PWM hier in op een periode van 50Hz, de servo's deden het niet goed op 20Hz die nodig is voor de
  //ultrasonic distance sensor trig pulse. Hopelijk doet de sensor t wel met een snellere puls
  TIM1_TimeBaseStructure.TIM_Period = 48000; 
  TIM1_TimeBaseStructure.TIM_Prescaler = 10; //10 maakt 50Hz 25 maakt 20Hz
  TIM1_TimeBaseStructure.TIM_ClockDivision = 0; //prescaler van de system clock
  TIM1_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //timer telt omhoog
  TIM_TimeBaseInit(TIM1, &TIM1_TimeBaseStructure);  
  
  /* Channel 1, 2,3 Configuration in PWM mode */
  TIM1_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;
  TIM1_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  //TIM1_OCInitStructure.TIM_OutputNState = TIM_OutputNState_Enable; //niet nodig
  TIM1_OCInitStructure.TIM_Pulse = panmid;
  TIM1_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;  //in rust is de PWM dan laag
  //TIM1_OCInitStructure.TIM_OCNPolarity = TIM_OCNPolarity_High;  //niet nodig, ik gebruik geen N kanalen
  TIM1_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Set;
  TIM1_OCInitStructure.TIM_OCNIdleState = TIM_OCIdleState_Reset;

  TIM_OC1Init(TIM1, &TIM1_OCInitStructure); //set CH1

  //nu CH2
  TIM1_OCInitStructure.TIM_Pulse = tiltmid;
  TIM_OC2Init(TIM1, &TIM1_OCInitStructure);

  //nu CH3
  TIM1_OCInitStructure.TIM_Pulse = 22;
  TIM_OC3Init(TIM1, &TIM1_OCInitStructure);

  /* TIM1 enable counter */
  TIM_Cmd(TIM1, ENABLE);

  /* TIM1 main Output Enable */
  TIM_CtrlPWMOutputs(TIM1, ENABLE);	//uit 7PWM_Output example

  //TIM2 instellen, CH1 wordt gebruikt om een LED te PWM-en en CH4 als irq generator met irq functie
  /* TIM2 Time base configuration */
  TIM2_TimeBaseStructure.TIM_Period = 65535; 
  TIM2_TimeBaseStructure.TIM_Prescaler = 0;
  TIM2_TimeBaseStructure.TIM_ClockDivision = 0;
  TIM2_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

  TIM_TimeBaseInit(TIM2, &TIM2_TimeBaseStructure); //schrijft alle 4 voorgaande waardes weg in de TIM2 registers

  /* Compute the prescaler value */
  //PrescalerValue = (uint16_t) (SystemCoreClock / 12000000) - 1;	//is dus 24E6 /12E6 -1 is dus 1
  PrescalerValue = 0; //ik maak hem hardcoded 0, TIM2 clk wordt dan gelijk aan system clk is 24Mhz, gaf mooie waarde voor LED pwm

  /* Prescaler configuration */
  TIM_PrescalerConfig(TIM2, PrescalerValue, TIM_PSCReloadMode_Immediate); //prescaler waarde inladen

  /* PWM1 Mode configuration: Channel1 */
  //CH1 van TIM2 gaat de LED aan/uit PWM-en
  TIM2_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;	//pwm mode kiezen
  TIM2_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;	//en dit enablen
  TIM2_OCInitStructure.TIM_Pulse = 0;	 //startup duty cycle voor channel 1 instellen, 0=led uit
  TIM2_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;	
  TIM_OC1Init(TIM2, &TIM2_OCInitStructure); 
  TIM_OC1PreloadConfig(TIM2, TIM_OCPreload_Enable);

  //Channel4 genereert een interrupt
  TIM2_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM2_OCInitStructure.TIM_Pulse = CCR4_Val;
  TIM_OC4Init(TIM2, &TIM2_OCInitStructure);
  TIM_OC4PreloadConfig(TIM2, TIM_OCPreload_Disable);

  /* TIM2 CH4 Interrupt enable */
  TIM_ITConfig(TIM2, TIM_IT_CC4, ENABLE);

  TIM_ARRPreloadConfig(TIM2, ENABLE);

  /* TIM2 enable counter */
  TIM_Cmd(TIM2, ENABLE);
  
  //TIM15 timebase op 1uS / 1MHz in stellen
  TIM15_TimeBaseStructure.TIM_Prescaler = 24;
  TIM15_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
  TIM15_TimeBaseStructure.TIM_Period = 65535;  
  TIM15_TimeBaseStructure.TIM_ClockDivision = 0;
  TIM15_TimeBaseStructure.TIM_RepetitionCounter = 0;  

  TIM_TimeBaseInit(TIM15, &TIM15_TimeBaseStructure); 	 

  //instellen TIM15 CH1 voor input capture
  //capture op beide flanken (BothEdge)
  TIM15_ICInitStructure.TIM_Channel = TIM_Channel_1;
  TIM15_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_BothEdge;
  TIM15_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI;
  TIM15_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1;
  TIM15_ICInitStructure.TIM_ICFilter = 0x0;

  TIM_ICInit(TIM15, &TIM15_ICInitStructure);
  
  //instellen TIM15 CH2 in output compare mode die irq geeft als TIM15 65535 is geworden, dit is vlak voor overflow!
  //deze gebruik ik om te zien of TIM15 overflowt terwijl CH1 tussen response op opgaande en neergaande flank zit
  //Output Compare Toggle Mode configuration: Channel2
  TIM15_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM15_OCInitStructure.TIM_Pulse = 65535;

  TIM_OC2Init(TIM15, &TIM15_OCInitStructure);

  TIM_OC2PreloadConfig(TIM15, TIM_OCPreload_Disable);	 

  /* TIM enable counter */
  TIM_Cmd(TIM15, ENABLE);

  /* Enable the CC1 Interrupt Request */
  TIM_ITConfig(TIM15, TIM_IT_CC1, ENABLE);	 //CC1 is voor capture op flanken, CC2 (set/reset ik in stm32f10x_it.c) om TIM overflow te detecteren

  delayms(1); 
}

//Configures the different system clocks. (RCC = Reset and Clock Control
void RCC_Configuration(void)
{
  /* TIM1 + TIM15 + TIM2 + TIM3 + TIM4 clock enable */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE); //APB is Advanced Perhiperal Bus
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM15, ENABLE); 
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);	  
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);

  /* GPIOA and GPIOB and GPIOC clock enable */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_AFIO, ENABLE);
}



//Configure I/O pins voor TIM1 + TIM2 + TIM3 + TIM4 +TIM15 + PB14 los
void GPIO_Configuration(void)
{	
	GPIO_InitTypeDef TIM1GPIO_InitStructure;
	GPIO_InitTypeDef TIM2GPIO_InitStructure;
	GPIO_InitTypeDef TIM3GPIO_InitStructure;
	GPIO_InitTypeDef TIM4GPIO_InitStructure;
	GPIO_InitTypeDef TIM15GPIO_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure; //voor PB13 instellen

	//TIM1
	TIM1GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11;  //PA8, PA9, PA10, PA11
  	TIM1GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	TIM1GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOA, &TIM1GPIO_InitStructure); 

	//TIM2 
	TIM2GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3;  //PA0, PA1, PA2, PA3
  	TIM2GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	TIM2GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOA, &TIM2GPIO_InitStructure); 

	//TIM3
	//#ifdef STM32F10X_CL
	#ifdef PORTC_EN_REMAP
  	/*GPIOB Configuration: TIM3 channel1, 2, 3 and 4 */
  	TIM3GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9;
  	TIM3GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	TIM3GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOC, &TIM3GPIO_InitStructure);

  	GPIO_PinRemapConfig(GPIO_FullRemap_TIM3, ENABLE);	 //zie refmanual pag117 voor pinnen TIM3 na remap

	#else
  	/* GPIOA Configuration:TIM3 Channel1, 2, 3 and 4 as alternate function push-pull */
  	TIM3GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7;
  	TIM3GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	TIM3GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOA, &TIM3GPIO_InitStructure);

  	TIM3GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1;
  	GPIO_Init(GPIOB, &TIM3GPIO_InitStructure);
	#endif

	//TIM4 (ga ik niet remappen)
	TIM4GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9;  //PB6,PB7,PB8,PB9
  	TIM4GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	TIM4GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOB, &TIM4GPIO_InitStructure); //GPIOB zitten de TIM4 outputs op als je ze niet remapt
	
	//TIM15 doe ik full remap dus CH1 en CH3 komen op PB14 en PB15
	//eerst CH1 als input voor input capture mode
  	TIM15GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_14;
  	TIM15GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  	TIM15GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOB, &TIM15GPIO_InitStructure);

	//nu TIM15 CH2 als output 
	TIM15GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_15;
  	TIM15GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	TIM15GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOB, &TIM15GPIO_InitStructure);

  	GPIO_PinRemapConfig(GPIO_Remap_TIM15, ENABLE);	 

	//PB13 als I/O voor bitbanging 10uS puls, PB12 als debugled
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_12;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
}

//Configure the nested vectored interrupt controller.
void NVIC_Configuration(void)
{
  //priority getal lager is hogere prio, bijvoorbeeld reset is hoogste prio is hardcoded -3
  /* Enable TIM2 global Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

  NVIC_Init(&NVIC_InitStructure);

  // Disable the TIM15 global Interrupt (control of this interrupt arranged via meetafstand()  )
  NVIC_InitStructure.NVIC_IRQChannel = TIM1_BRK_TIM15_IRQn;	 //dit vond ik in stm32f10x.h voor medium density value line uC's hopelijk werkt t
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = DISABLE;
  NVIC_Init(&NVIC_InitStructure); 
}

void debugfunctie(void)
{
	TIM_Cmd(TIM3, ENABLE);
	
	//debuggen van het teveel stroom trekken van de 8 servo's tegelijk
	setTIM3CHxDuty(1,armLAnaarachter);
	delayms(250);
	setTIM3CHxDuty(1,armLAnaarvoren);
	delayms(250);
}

void debugled(uint8_t aanuit)
{
	if(aanuit == aan)
  		GPIOB->BSRR = 0x00001000;//set PB12
	else if	(aanuit == uit)
    	GPIOB->BRR  = 0x00001000;//clear PB12
}

